=== plugins/CMakeLists.txt ===
IF(WIN32)
  SET(CMAKE_EXE_LINKER_FLAGS ${CMAKE_EXE_LINKER_FLAGS} "-Wl,--enable-runtime-pseudo-reloc")
ENDIF()

ADD_DEFINITIONS(-DQT_PLUGIN)
ADD_DEFINITIONS(-DQT_DLL)
ADD_DEFINITIONS(-D_REENTRANT)

FOREACH(NAME ${STELLARIUM_PLUGINS})
  STRING(TOUPPER ${NAME} NAME_UP)
  IF(USE_PLUGIN_${NAME_UP})
    ADD_SUBDIRECTORY(${NAME})
  ENDIF()
ENDFOREACH()
