=== plugins/EquationOfTime/CMakeLists.txt ===
SET(EQUATIONOFTIME_MAJOR "0")
SET(EQUATIONOFTIME_MINOR "1")
SET(EQUATIONOFTIME_PATCH "1")
SET(EQUATIONOFTIME_VERSION "${EQUATIONOFTIME_MAJOR}.${EQUATIONOFTIME_MINOR}.${EQUATIONOFTIME_PATCH}")

IF(APPLE)
	SET(CMAKE_INSTALL_PREFIX $ENV{HOME}/Library/Application\ Support/Stellarium)
ElSE(APPLE)
	SET(CMAKE_INSTALL_PREFIX $ENV{HOME}/.stellarium)
ENDIF(APPLE)

ADD_DEFINITIONS(-DEQUATIONOFTIME_PLUGIN_VERSION="${EQUATIONOFTIME_VERSION}")

ADD_SUBDIRECTORY( src )

INSTALL(FILES DESTINATION "modules/EquationOfTime")
