=== debian/changelog ===
stellarium (0.13.3-2) unstable; urgency=medium

  [ Marcus Lundblad ]
  * Install appstream appdata.

  [ Tomasz Buchert ]
  * d/gbp.conf: update config
  * d/patches: Fix Qt linking problem (Closes: #786715)

 -- Tomasz Buchert <tomasz@debian.org>  Wed, 03 Jun 2015 12:59:37 +0200

stellarium (0.13.3-1) unstable; urgency=medium

  * Imported Upstream version 0.13.3
  * Bugs fixed (Closes: #779046)

 -- Tomasz Buchert <tomasz@debian.org>  Sat, 25 Apr 2015 22:20:59 +0200

stellarium (0.13.2-1) unstable; urgency=medium

  * Imported Upstream version 0.13.2

 -- Tomasz Buchert <tomasz.buchert@inria.fr>  Tue, 20 Jan 2015 19:20:13 +0100
