=== debian/control ===
Source: stellarium
Section: science
Priority: optional
Maintainer: Debian Astro Maintainers <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Tomasz Buchert <tomasz@debian.org>
Build-Depends: debhelper (>= 9), cmake (>= 3.0), doxygen, zlib1g-dev,
 qtbase5-dev (>= 5.3), libqt5opengl5-dev (>= 5.3),
 qtdeclarative5-dev (>= 5.3), qtdeclarative5-dev-tools (>= 5.3),
 qtquick1-5-dev (>= 5.3), qtscript5-dev (>= 5.3), qttools5-dev (>= 5.3),
 qttools5-dev-tools (>= 5.3), mesa-common-dev
Standards-Version: 3.9.6
Homepage: http://www.stellarium.org
Vcs-Git: git://anonscm.debian.org/debian-astro/packages/stellarium.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-astro/packages/stellarium.git

Package: stellarium
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, stellarium-data (= ${source:Version}),
 qtquick1-qml-plugins (>= 5.3)
Description: real-time photo-realistic sky generator
 Stellarium renders 3D photo-realistic skies in real-time. With Stellarium, you
 really see what you can see with your eyes, binoculars or a small telescope.
 .
 Some features:
  - default star catalogue with over 600 thousand stars,
  - information about the brightest stars (spectral type, distance, etc.),
  - downloadable star catalogue extensions, for up to 210 million stars,
  - all New General Catalogue (NGC) objects,
  - images of almost all Messier objects and the Milky Way,
  - real time positions of the planets and their satellites,
  - 13 different cultures with their constellations,
  - artistic illustrations of the 88 Western constellations,
  - very realistic atmosphere, sunrise and sunset,
  - 7 panoramic landscapes (more can be made or downloaded from the website),
  - scripting with ECMAScript,
  - plug-in support: Stellarium comes with 8 plug-ins by default, including:
  - artificial satellites plug-in (updated from an on-line TLE database),
  - ocular simulation plug-in (shows how objects look like in a given ocular),
  - Solar System editor plug-in (imports comet and asteroid data from the MPC),
  - telescope control plug-in (Meade LX200 and Celestron NexStar compatible).
 .
 Stellarium should not be used for very high accurate calculation or ephemerids
 like eclipse predictions. However, it is the ideal program to prepare an
 observation evening with naked eye, binocular, or small telescope.

Package: stellarium-data
Architecture: all
Recommends: stellarium (= ${source:Version})
Depends: ${misc:Depends}, fonts-dejavu-core (>= 2.33)
Description: Stellarium data files
 Stellarium renders 3D photo-realistic skies in real-time. With Stellarium, you
 really see what you can see with your eyes, binoculars or a small telescope.
 .
 This package contains data files required by Stellarium. They include
 textures, star catalogues and translations.
